Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 2232)
@@ -3924,188 +4739,277 @@
         
         exn(:) = (hyp(nzub:nzut) / 100000.0_wp )**0.286_wp          !< Exner function
+!        
+!--     First, treat horizontal surface elements
+
+        DO  m = 1, surf_usm_h%ns
+!
+!--        Get indices of respective grid point
+           i = surf_usm_h%i(m)
+           j = surf_usm_h%j(m)
+           k = surf_usm_h%k(m)
+!
+!--        TODO - how to calculate lambda_surface for horizontal surfaces
+!--        (lambda_surface is set according to stratification in land surface model)
+!--        MS: ???
+           IF ( surf_usm_h%ol(m) >= 0.0_wp )  THEN
+              lambda_surface = surf_usm_h%lambda_surf(m)
+           ELSE
+              lambda_surface = surf_usm_h%lambda_surf(m)
+           ENDIF
             
-!--    
-        DO l = startenergy, endenergy
-!--         Calculate frequently used parameters
-            d = surfl(id,l)
-            k = surfl(iz,l)
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-
-!--         TODO - how to calculate lambda_surface for horizontal surfaces
-!--         (lambda_surface is set according to stratification in land surface model)
-            IF ( ol(j,i) >= 0.0_wp )  THEN
-                lambda_surface = lambda_surf(l)
-            ELSE
-                lambda_surface = lambda_surf(l)
-            ENDIF
+           pt1  = pt(k,j,i)
+!
+!--        calculate rho * cp coefficient at surface layer
+           rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
+!
+!--        Calculate aerodyamic resistance. 
+!--        Calculation for horizontal surfaces follows LSM formulation
+!--        pt, us, ts are not available for the prognostic time step,
+!--        data from the last time step is used here.
+               
+           r_a = ( pt1 - t_surf_h(m) / exn(k) ) /                              &
+                 ( surf_usm_h%ts(m) * surf_usm_h%us(m) + 1.0E-10_wp )
+                
+!--        make sure that the resistance does not drop to zero
+           IF ( ABS(r_a) < 1.0E-10_wp )  r_a = 1.0E-10_wp
+                
+!--        the parameterization is developed originally for larger scales
+!--        (compare with remark in TUF-3D)
+!--        our first experiences show that the parameterization underestimates
+!--        r_a in meter resolution.
+!--        temporary solution - multiplication by magic constant :-(.
+           r_a = r_a * ra_horiz_coef
+                
+!--        factor for shf_eb
+           f_shf  = rho_cp / r_a
+        
+!--        add LW up so that it can be removed in prognostic equation
+           surf_usm_h%rad_net_l(m) = surf_usm_h%rad_in_sw(m)  -                &
+                                     surf_usm_h%rad_out_sw(m) +                &
+                                     surf_usm_h%rad_in_lw(m)  -                &
+                                     surf_usm_h%rad_out_lw(m)
+
+!--        numerator of the prognostic equation
+           coef_1 = surf_usm_h%rad_net_l(m) +                                  & 
+                   ( 3.0_wp + 1.0_wp ) * surf_usm_h%emiss_surf(m) * sigma_sb * &
+                                       t_surf_h(m) ** 4 +                      &  
+                                       f_shf * pt1 +                           &
+                                       lambda_surface * t_wall_h(nzb_wall,m)
+
+!--        denominator of the prognostic equation
+           coef_2 = 4.0_wp * surf_usm_h%emiss_surf(m) * sigma_sb *            &
+                             t_surf_h(m) ** 3                                 &
+                           + lambda_surface + f_shf / exn(k)
+
+!--        implicit solution when the surface layer has no heat capacity,
+!--        otherwise use RK3 scheme.
+           t_surf_h_p(m) = ( coef_1 * dt_3d * tsc(2) +                        &
+                             surf_usm_h%c_surface(m) * t_surf_h(m) ) /        & 
+                           ( surf_usm_h%c_surface(m) + coef_2 * dt_3d * tsc(2) ) 
+
+!--        add RK3 term
+           t_surf_h_p(m) = t_surf_h_p(m) + dt_3d * tsc(3) *                   &
+                           surf_usm_h%tt_surface_m(m)
             
-            pt1  = pt(k,j,i)
-
-!--         calculate rho * cp coefficient at surface layer
-            rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
-
-!--         calculate aerodyamic resistance. 
-            IF ( d == iroof )  THEN
-!--             calculation for horizontal surfaces follows LSM formulation
-!--             pt, us, ts are not available for the prognostic time step,
-!--             data from the last time step is used here.
+!--        calculate true tendency
+           stend = ( t_surf_h_p(m) - t_surf_h(m) - dt_3d * tsc(3) *           &
+                     surf_usm_h%tt_surface_m(m)) / ( dt_3d  * tsc(2) )
+
+!--        calculate t_surf tendencies for the next Runge-Kutta step
+           IF ( timestep_scheme(1:5) == 'runge' )  THEN
+              IF ( intermediate_timestep_count == 1 )  THEN
+                 surf_usm_h%tt_surface_m(m) = stend
+              ELSEIF ( intermediate_timestep_count <                          &
+                        intermediate_timestep_count_max )  THEN
+                 surf_usm_h%tt_surface_m(m) = -9.5625_wp * stend +            &
+                                     5.3125_wp * surf_usm_h%tt_surface_m(m)
+              ENDIF
+           ENDIF
+
+!--        in case of fast changes in the skin temperature, it is required to
+!--        update the radiative fluxes in order to keep the solution stable
+           IF ( ABS( t_surf_h_p(m) - t_surf_h(m) ) > 1.0_wp )  THEN
+              force_radiation_call_l = .TRUE.
+           ENDIF
+!           
+!--        for horizontal surfaces is pt(nzb_s_inner(j,i),j,i) = pt_surf.
+!--        there is no equivalent surface gridpoint for vertical surfaces.
+!--        pt(k,j,i) is calculated for all directions in diffusion_s
+!--        using surface and wall heat fluxes
+           pt(k-1,j,i) = t_surf_h_p(m) / exn(k)  ! not for vertical surfaces
+
+!--        calculate fluxes
+!--        rad_net_l is never used!           
+           surf_usm_h%rad_net_l(m) = surf_usm_h%rad_net_l(m) +                &
+                                     3.0_wp * sigma_sb *                      &
+                                     t_surf_h(m)**4 - 4.0_wp * sigma_sb *     &
+                                     t_surf_h(m)**3 * t_surf_h_p(m)
+           surf_usm_h%wghf_eb(m)   = lambda_surface *                         &
+                                      ( t_surf_h_p(m) - t_wall_h(nzb_wall,m) )
+!
+!--        ground/wall/roof surface heat flux
+           surf_usm_h%wshf_eb(m)   = - f_shf  * ( pt1 - t_surf_h_p(m) )
+!           
+!--        store kinematic surface heat fluxes for utilization in other processes
+!--        diffusion_s, surface_layer_fluxes,...
+           surf_usm_h%shf(m) = surf_usm_h%wshf_eb(m) / rho_cp
+
+       ENDDO
+!
+!--    Now, treat vertical surface elements
+       DO  l = 0, 3
+          DO  m = 1, surf_usm_v(l)%ns
+!
+!--          Get indices of respective grid point
+             i = surf_usm_v(l)%i(m)
+             j = surf_usm_v(l)%j(m)
+             k = surf_usm_v(l)%k(m)
+!
+!--          TODO - how to calculate lambda_surface for horizontal (??? do you mean verical ???) surfaces
+!--          (lambda_surface is set according to stratification in land surface model).
+!--          Please note, for vertical surfaces no ol is defined, since 
+!--          stratification is not considered in this case.
+             lambda_surface = surf_usm_v(l)%lambda_surf(m)
+            
+             pt1  = pt(k,j,i)
+!
+!--          calculate rho * cp coefficient at surface layer
+             rho_cp  = cp * hyp(k) / ( r_d * pt1 * exn(k) )
+
+!--          Calculation of r_a for vertical surfaces
+!--
+!--          heat transfer coefficient for forced convection along vertical walls
+!--          follows formulation in TUF3d model (Krayenhoff & Voogt, 2006)
+!--            
+!--          H = httc (Tsfc - Tair)
+!--          httc = rw * (11.8 + 4.2 * Ueff) - 4.0
+!--            
+!--                rw: wall patch roughness relative to 1.0 for concrete
+!--                Ueff: effective wind speed
+!--                - 4.0 is a reduction of Rowley et al (1930) formulation based on
+!--                Cole and Sturrock (1977)
+!--           
+!--                Ucan: Canyon wind speed
+!--                wstar: convective velocity
+!--                Qs: surface heat flux
+!--                zH: height of the convective layer
+!--                wstar = (g/Tcan*Qs*zH)**(1./3.)
                 
-                r_a = (pt1 - t_surf(l)/exn(k)) / (ts(j,i) * us(j,i) + 1.0E-10_wp)
+!--          Effective velocity components must always 
+!--          be defined at scalar grid point. The wall normal component is 
+!--          obtained by simple linear interpolation. ( An alternative would
+!--          be an logarithmic interpolation. )
+             u1 = ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp
+             v1 = ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp
+             w1 = ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp
                 
-!--             make sure that the resistance does not drop to zero
-                IF ( ABS(r_a) < 1.0E-10_wp )  r_a = 1.0E-10_wp
-                
-!--             the parameterization is developed originally for larger scales
-!--             (compare with remark in TUF-3D)
-!--             our first experiences show that the parameterization underestimates
-!--             r_a in meter resolution.
-!--             temporary solution - multiplication by magic constant :-(.
-                r_a = r_a * ra_horiz_coef
-                
-!--             factor for shf_eb
-                f_shf  = rho_cp / r_a
-            ELSE
-!--             calculation of r_a for vertical surfaces
-!--
-!--             heat transfer coefficient for forced convection along vertical walls
-!--             follows formulation in TUF3d model (Krayenhoff & Voogt, 2006)
-!--            
-!--             H = httc (Tsfc - Tair)
-!--             httc = rw * (11.8 + 4.2 * Ueff) - 4.0
-!--            
-!--                   rw: wall patch roughness relative to 1.0 for concrete
-!--                   Ueff: effective wind speed
-!--                   - 4.0 is a reduction of Rowley et al (1930) formulation based on
-!--                   Cole and Sturrock (1977)
-!--            
-!--                   Ucan: Canyon wind speed
-!--                   wstar: convective velocity
-!--                   Qs: surface heat flux
-!--                   zH: height of the convective layer
-!--                   wstar = (g/Tcan*Qs*zH)**(1./3.)
-                
-!--             staggered grid needs to be taken into consideration
-                IF ( d == inorth )  THEN
-                    u1 = (u(k,j,i)+u(k,j,i+1))*0.5_wp
-                    v1 = v(k,j+1,i)
-                ELSE IF ( d == isouth )  THEN
-                    u1 = (u(k,j,i)+u(k,j,i+1))*0.5_wp
-                    v1 = v(k,j,i)
-                ELSE IF ( d == ieast )  THEN
-                    u1 = u(k,j,i+1)
-                    v1 = (v(k,j,i)+v(k,j+1,i))*0.5_wp
-                ELSE IF ( d == iwest )  THEN
-                    u1 = u(k,j,i)
-                    v1 = (v(k,j,i)+v(k,j+1,i))*0.5_wp
-                ELSE
-                    STOP
-                ENDIF
-                w1 = (w(k,j,i)+w(k-1,j,i))*0.5_wp
-                
-                Ueff = SQRT(u1**2 + v1**2 + w1**2)
-                httc = roughness_wall(l) * (11.8 + 4.2 * Ueff) - 4.0
-                f_shf  = httc
-            ENDIF
-        
-!--         add LW up so that it can be removed in prognostic equation
-            rad_net_l(l) = surfinsw(l) - surfoutsw(l) + surfinlw(l) - surfoutlw(l)
-
-!--         numerator of the prognostic equation
-            coef_1 = rad_net_l(l) +    &    ! coef +1 corresponds to -lwout included in calculation of radnet_l
-                     (3.0_wp+1.0_wp) * emiss_surf(l) * sigma_sb * t_surf(l) ** 4 +      &  
-                     f_shf  * pt1 +                                                     &
-                     lambda_surface * t_wall(nzb_wall,l)
-
-!--         denominator of the prognostic equation
-            coef_2 = 4.0_wp * emiss_surf(l) * sigma_sb * t_surf(l) ** 3                 &
-                         + lambda_surface + f_shf / exn(k)
-
-!--         implicit solution when the surface layer has no heat capacity,
-!--         otherwise use RK3 scheme.
-            t_surf_p(l) = ( coef_1 * dt_3d * tsc(2) + c_surface(l) * t_surf(l) ) /      & 
-                              ( c_surface(l) + coef_2 * dt_3d * tsc(2) ) 
-
-!--         add RK3 term
-            t_surf_p(l) = t_surf_p(l) + dt_3d * tsc(3) * tt_surface_m(l)
+             Ueff   = SQRT( u1**2 + v1**2 + w1**2 )
+             httc   = surf_usm_v(l)%roughness_wall(m) *                       &
+                       ( 11.8_wp + 4.2_wp * Ueff ) - 4.0_wp
+             f_shf  = httc
+
+!--          add LW up so that it can be removed in prognostic equation
+             surf_usm_v(l)%rad_net_l(m) = surf_usm_v(l)%rad_in_sw(m)  -        &
+                                          surf_usm_v(l)%rad_out_sw(m) +        &
+                                          surf_usm_v(l)%rad_in_lw(m)  -        &
+                                          surf_usm_v(l)%rad_out_lw(m)
+
+!--           numerator of the prognostic equation
+              coef_1 = surf_usm_v(l)%rad_net_l(m) +                            & ! coef +1 corresponds to -lwout included in calculation of radnet_l
+               ( 3.0_wp + 1.0_wp ) * surf_usm_v(l)%emiss_surf(m) * sigma_sb *  &
+                                     t_surf_v(l)%t(m) ** 4 +                   &  
+                                     f_shf * pt1 +                             &
+                                     lambda_surface * t_wall_v(l)%t(nzb_wall,m)
+
+!--           denominator of the prognostic equation
+              coef_2 = 4.0_wp * surf_usm_v(l)%emiss_surf(m) * sigma_sb *       &
+                                t_surf_v(l)%t(m) ** 3                          &
+                              + lambda_surface + f_shf / exn(k)
+
+!--           implicit solution when the surface layer has no heat capacity,
+!--           otherwise use RK3 scheme.
+              t_surf_v_p(l)%t(m) = ( coef_1 * dt_3d * tsc(2) +                 &
+                             surf_usm_v(l)%c_surface(m) * t_surf_v(l)%t(m) ) / & 
+                           ( surf_usm_v(l)%c_surface(m) + coef_2 * dt_3d * tsc(2) ) 
+
+!--           add RK3 term
+              t_surf_v_p(l)%t(m) = t_surf_v_p(l)%t(m) + dt_3d * tsc(3) *       &
+                                surf_usm_v(l)%tt_surface_m(m)
             
-!--         calculate true tendency
-            stend = (t_surf_p(l) - t_surf(l) - dt_3d * tsc(3) * tt_surface_m(l)) / (dt_3d  * tsc(2))
-
-!--         calculate t_surf tendencies for the next Runge-Kutta step
-            IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                    tt_surface_m(l) = stend
-                ELSEIF ( intermediate_timestep_count <                                  &
-                         intermediate_timestep_count_max )  THEN
-                    tt_surface_m(l) = -9.5625_wp * stend + 5.3125_wp                    &
-                                       * tt_surface_m(l)
-                ENDIF
-            ENDIF
-
-!--         in case of fast changes in the skin temperature, it is required to
-!--         update the radiative fluxes in order to keep the solution stable
-            IF ( ABS( t_surf_p(l) - t_surf(l) ) > 1.0_wp )  THEN
-               force_radiation_call_l = .TRUE.
-            ENDIF
-            
-!--         for horizontal surfaces is pt(nzb_s_inner(j,i),j,i) = pt_surf.
-!--         there is no equivalent surface gridpoint for vertical surfaces.
-!--         pt(k,j,i) is calculated for all directions in diffusion_s
-!--         using surface and wall heat fluxes
-            IF ( d == iroof )  THEN
-               pt(nzb_s_inner(j,i),j,i) = t_surf_p(l) / exn(k)
-            ENDIF
-
-!--         calculate fluxes
-!--         rad_net_l is never used!           
-            rad_net_l(l)     = rad_net_l(l) + 3.0_wp * sigma_sb                         &
-                                * t_surf(l)**4 - 4.0_wp * sigma_sb                      &
-                                * t_surf(l)**3 * t_surf_p(l)
-            wghf_eb(l)       = lambda_surface * (t_surf_p(l) - t_wall(nzb_wall,l))
-
-!--         ground/wall/roof surface heat flux
-            wshf_eb(l)  = - f_shf  * ( pt1 - t_surf_p(l) )
-            
-!--         store kinematic surface heat fluxes for utilization in other processes
-!--         diffusion_s, surface_layer_fluxes,...
-            IF ( d == iroof )  THEN
-!--             shf is used in diffusion_s and also
-!--             for calculation of surface layer fluxes
-!--             update for horizontal surfaces
-                shf(j,i) = wshf_eb(l) / rho_cp
-            ELSE
-!--             surface heat flux for vertical surfaces
-!--             used in diffusion_s
-                wshf(l) = wshf_eb(l) / rho_cp
-            ENDIF
+!--           calculate true tendency
+              stend = ( t_surf_v_p(l)%t(m) - t_surf_v(l)%t(m) - dt_3d * tsc(3) *&
+                        surf_usm_v(l)%tt_surface_m(m) ) / ( dt_3d  * tsc(2) )
+
+!--           calculate t_surf tendencies for the next Runge-Kutta step
+              IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                 IF ( intermediate_timestep_count == 1 )  THEN
+                    surf_usm_v(l)%tt_surface_m(m) = stend
+                 ELSEIF ( intermediate_timestep_count <                        &
+                          intermediate_timestep_count_max )  THEN
+                    surf_usm_v(l)%tt_surface_m(m) = -9.5625_wp * stend +       &
+                                     5.3125_wp * surf_usm_h%tt_surface_m(m)
+                 ENDIF
+              ENDIF
+
+!--           in case of fast changes in the skin temperature, it is required to
+!--           update the radiative fluxes in order to keep the solution stable
+              IF ( ABS( t_surf_v_p(l)%t(m) - t_surf_v(l)%t(m) ) > 1.0_wp )  THEN
+                 force_radiation_call_l = .TRUE.
+              ENDIF
+
+!--           calculate fluxes
+!--           rad_net_l is never used!           
+              surf_usm_v(l)%rad_net_l(m) = surf_usm_v(l)%rad_net_l(m) +        &
+                                     3.0_wp * sigma_sb *                       &
+                                     t_surf_v(l)%t(m)**4 - 4.0_wp * sigma_sb * &
+                                     t_surf_v(l)%t(m)**3 * t_surf_v_p(l)%t(m)
+
+              surf_usm_v(l)%wghf_eb(m)   = lambda_surface *                    &
+                                     ( t_surf_v_p(l)%t(m) - t_wall_v(l)%t(nzb_wall,m) )
+
+!--           ground/wall/roof surface heat flux
+              surf_usm_v(l)%wshf_eb(m)   = - f_shf  * ( pt1 - t_surf_v_p(l)%t(m) )
+
+!           
+!--           store kinematic surface heat fluxes for utilization in other processes
+!--           diffusion_s, surface_layer_fluxes,...
+              surf_usm_v(l)%shf(m) = surf_usm_v(l)%wshf_eb(m) / rho_cp
+
+           ENDDO
 
         ENDDO
-        
-        
+!
+!--     Add-up anthropogenic heat, for now only at upward-facing surfaces
         IF ( usm_anthropogenic_heat  .AND.  &
              intermediate_timestep_count == intermediate_timestep_count_max )  THEN
-!--         application of the additional anthropogenic heat sources
-!--         we considere the traffic for now so all heat is absorbed
-!--         to the first layer, generalization would be worth
+!--        application of the additional anthropogenic heat sources
+!--        we considere the traffic for now so all heat is absorbed
+!--        to the first layer, generalization would be worth. 
             
-!--         calculation of actual profile coefficient
-!--         ??? check time_since_reference_point ???
-            dtime = mod(simulated_time + time_utc_init, 24.0_wp*3600.0_wp)
-            dhour = INT(dtime/3600.0_wp)
-!--         linear interpolation of coeficient
-            acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(dhour) + (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(dhour+1)
-            DO i = nxl, nxr
-                DO j = nys, nyn
-                    IF ( aheat(j,i) > 0.0_wp )  THEN
-!--                     TODO the increase of pt in box i,j,nzb_s_inner(j,i)+1 in time dt_3d 
-!--                     given to anthropogenic heat aheat*acoef (W*m-2)
-!--                     k = nzb_s_inner(j,i)+1
-!--                     pt(k,j,i) = pt(k,j,i) + aheat(j,i)*acoef*dt_3d/(exn(k)*rho_cp*dz)
-!--                     Instead of this, we can adjust shf in case AH only at surface
-                        shf(j,i) = shf(j,i) + aheat(j,i)*acoef * ddx * ddy / rho_cp
-                    ENDIF
-                ENDDO
-            ENDDO
+!--        calculation of actual profile coefficient
+!--        ??? check time_since_reference_point ???
+           dtime = mod(simulated_time + time_utc_init, 24.0_wp*3600.0_wp)
+           dhour = INT(dtime/3600.0_wp)
+!--        linear interpolation of coeficient
+           acoef = (REAL(dhour+1,wp)-dtime/3600.0_wp)*aheatprof(dhour) + (dtime/3600.0_wp-REAL(dhour,wp))*aheatprof(dhour+1)
+
+           DO m = 1, surf_usm_h%ns
+!
+!--           Get indices of respective grid point
+              i = surf_usm_h%i(m)
+              j = surf_usm_h%j(m)
+              k = surf_usm_h%k(m)
+
+              IF ( aheat(j,i) > 0.0_wp )  THEN
+!--              TODO the increase of pt in box i,j,nzb_s_inner(j,i)+1 in time dt_3d 
+!--              given to anthropogenic heat aheat*acoef (W*m-2)
+!--              k = nzb_s_inner(j,i)+1
+!--              pt(k,j,i) = pt(k,j,i) + aheat(j,i)*acoef*dt_3d/(exn(k)*rho_cp*dz)
+!--              Instead of this, we can adjust shf in case AH only at surface
+                 surf_usm_h%shf(m) = surf_usm_h%shf(m) +                       &
+                                   aheat(j,i) * acoef * ddx * ddy / rho_cp
+              ENDIF
+           ENDDO
+
         ENDIF
         
@@ -4113,16 +5017,15 @@
 !--     get the borders from neighbours
         CALL exchange_horiz( pt, nbgp )
-        CALL exchange_horiz_2d( shf )
-
-
-!--    calculation of force_radiation_call:
-!--    Make logical OR for all processes.
-!--    Force radiation call if at least one processor forces it.
-       IF ( intermediate_timestep_count == intermediate_timestep_count_max-1 )          &
-       THEN
+
+
+!--     calculation of force_radiation_call:
+!--     Make logical OR for all processes.
+!--     Force radiation call if at least one processor forces it.
+        IF ( intermediate_timestep_count == intermediate_timestep_count_max-1 )&
+        THEN
 #if defined( __parallel )
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-              CALL mpi_allreduce( force_radiation_call_l, force_radiation_call,         &
-                                  1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
+          CALL MPI_ALLREDUCE( force_radiation_call_l, force_radiation_call,    &
+                              1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
 #else
           force_radiation_call = force_radiation_call_l
@@ -4130,5 +5033,4 @@
           force_radiation_call_l = .FALSE.
        ENDIF
-
 
     END SUBROUTINE usm_surface_energy_balance
@@ -4149,77 +5051,32 @@
       
 #if defined( __nopointer )
-       t_surf    = t_surf_p
-       t_wall    = t_wall_p
+       t_surf_h    = t_surf_h_p
+       t_wall_h    = t_wall_h_p
+       t_surf_v    = t_surf_v_p
+       t_wall_v    = t_wall_v_p
 #else
        SELECT CASE ( mod_count )
           CASE ( 0 )
-             t_surf  => t_surf_1; t_surf_p  => t_surf_2
-             t_wall     => t_wall_1;    t_wall_p     => t_wall_2
+!
+!--          Horizontal surfaces
+             t_surf_h  => t_surf_h_1; t_surf_h_p  => t_surf_h_2
+             t_wall_h     => t_wall_h_1;    t_wall_h_p     => t_wall_h_2
+!
+!--          Vertical surfaces
+             t_surf_v  => t_surf_v_1; t_surf_v_p  => t_surf_v_2
+             t_wall_v     => t_wall_v_1;    t_wall_v_p     => t_wall_v_2
           CASE ( 1 )
-             t_surf  => t_surf_2; t_surf_p  => t_surf_1
-             t_wall     => t_wall_2;    t_wall_p     => t_wall_1
+!
+!--          Horizontal surfaces
+             t_surf_h  => t_surf_h_2; t_surf_h_p  => t_surf_h_1
+             t_wall_h     => t_wall_h_2;    t_wall_h_p     => t_wall_h_1
+!
+!--          Vertical surfaces
+             t_surf_v  => t_surf_v_2; t_surf_v_p  => t_surf_v_1
+             t_wall_v     => t_wall_v_2;    t_wall_v_p     => t_wall_v_1
        END SELECT
 #endif
         
     END SUBROUTINE usm_swap_timelevel
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!
-!> This function applies the kinematic wall heat fluxes
-!> for walls in four directions for all gridboxes in urban layer.
-!> It is called out from subroutine prognostic_equations.
-!> TODO Compare performance with cycle runnig l=startwall,endwall...
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_wall_heat_flux
-    
-        IMPLICIT NONE
-
-        INTEGER(iwp)              ::  i,j,k,d,l             !< running indices
-        
-        DO l = startenergy, endenergy
-            j = surfl(iy,l)
-            i = surfl(ix,l)
-            k = surfl(iz,l)
-            d = surfl(id,l)
-            tend(k,j,i) = tend(k,j,i) + wshf(l) * ddxy2(d)
-        ENDDO
-
-    END SUBROUTINE usm_wall_heat_flux
- 
- 
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!
-!> This function applies the kinematic wall heat fluxes
-!> for walls in four directions around the gridbox i,j.
-!> It is called out from subroutine prognostic_equations.
-!------------------------------------------------------------------------------!
-    SUBROUTINE usm_wall_heat_flux_ij(i,j) 
-    
-        IMPLICIT NONE
-
-        INTEGER(iwp), INTENT(in)  ::  i,j                   !< indices of grid box
-        INTEGER(iwp)              ::  ii,jj,k,d,l
-        
-        DO l = startenergy, endenergy
-            jj = surfl(iy,l)
-            ii = surfl(ix,l)
-            IF ( ii == i  .AND.  jj == j ) THEN
-               k = surfl(iz,l)
-               IF ( k >=  nzb_s_inner(j,i)+1  .AND.  k <=  nzb_s_outer(j,i) ) THEN
-                  d = surfl(id,l)
-                  IF ( d >= 1 .and. d <= 4 )   THEN
-                     tend(k,j,i) = tend(k,j,i) + wshf(l) * ddxy2(d)
-                  ENDIF
-               ENDIF
-            ENDIF
-        ENDDO
-
-    END SUBROUTINE usm_wall_heat_flux_ij
- 
 
 !------------------------------------------------------------------------------!
@@ -4242,15 +5099,64 @@
        DO  i = 0, io_blocks-1
           IF ( i == io_group )  THEN
-             WRITE ( 14 )  't_surf                        '
+
+             WRITE ( 14 )  't_surf_h                      '
 #if defined( __nopointer )             
-             WRITE ( 14 )  t_surf
+             WRITE ( 14 )  t_surf_h
 #else
-             WRITE ( 14 )  t_surf_1
+             WRITE ( 14 )  t_surf_h_1
 #endif
-             WRITE ( 14 )  't_wall                        '
+             WRITE ( 14 )  't_surf_v(0)                   '
 #if defined( __nopointer )             
-             WRITE ( 14 )  t_wall
+             WRITE ( 14 )  t_surf_v(0)%t
 #else
-             WRITE ( 14 )  t_wall_1
+             WRITE ( 14 )  t_surf_v_1(0)%t
+#endif
+             WRITE ( 14 )  't_surf_v(1)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_surf_v(1)%t
+#else
+             WRITE ( 14 )  t_surf_v_1(1)%t
+#endif
+             WRITE ( 14 )  't_surf_v(2)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_surf_v(2)%t
+#else
+             WRITE ( 14 )  t_surf_v_1(2)%t
+#endif
+             WRITE ( 14 )  't_surf_v(3)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_surf_v(3)%t
+#else
+             WRITE ( 14 )  t_surf_v_1(3)%t
+#endif
+             WRITE ( 14 )  't_wall_h                      '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_wall_h
+#else
+             WRITE ( 14 )  t_wall_h_1
+#endif
+             WRITE ( 14 )  't_wall_v(0)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_wall_v(0)%t
+#else
+             WRITE ( 14 )  t_wall_v_1(0)%t
+#endif
+             WRITE ( 14 )  't_wall_v(1)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_wall_v(1)%t
+#else
+             WRITE ( 14 )  t_wall_v_1(1)%t
+#endif
+             WRITE ( 14 )  't_wall_v(2)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_wall_v(2)%t
+#else
+             WRITE ( 14 )  t_wall_v_1(2)%t
+#endif
+             WRITE ( 14 )  't_wall_v(3)                   '
+#if defined( __nopointer )             
+             WRITE ( 14 )  t_wall_v(3)%t
+#else
+             WRITE ( 14 )  t_wall_v_1(3)%t
 #endif
              WRITE ( 14 )  '*** end usm ***               '
